----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
----------------------------------LFT---------------------------------------------
----------------------------------------------------------------------------------
----------------------------------------------------------------------------------

-- SLASH --
SLASH_LFT1 = '/lft'; -- 3.
function SlashCmdList.LFT(msg, editbox) -- 4.
 LFTHippHopp()
end

--local r = {}


-- FRAMEFACTORY --
local requestFrames = {}

local function countFrames()
  local count = 0
  for _,_ in pairs(requestFrames) do count = count + 1 end
  return count
end

function collapseFrames()
  local c = 0
  for _,frame in pairs(requestFrames) do
	if frame.used then
		c = c + 1
		frame:SetPoint("TOPLEFT", 0, -70 + -20 * c)
	end
  end
end

local function getFrame(parent)
  for _,frame in pairs(requestFrames) do
    if not frame.used then
      -- can do some setup here based on parameters etc
      frame.used = true
	  frame:Show()
      return frame
    end
  end
  
	-- if you reached here no frame was unused, create a new one
	local count = countFrames() + 1
	requestFrames[count] = CreateFrame("Frame",nil,parent,"RequestRowTemplate")
	local frame = requestFrames[count]
	local name = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
	name:SetPoint("TOPLEFT",5,0)
	frame.nameString = name
	local d = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
	d:SetPoint("TOPLEFT",90,0)
	frame.dString = d
	local t = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
	t:SetPoint("TOPLEFT",225,0)
	frame.tString = t
	local sum = frame:CreateTexture(nil, "OVERLAY")
	sum:SetSize(16,16)
	sum:SetPoint("TOPLEFT",170,0)
	frame.sumTexture = sum
	local g = frame:CreateTexture(nil, "OVERLAY")
	g:SetSize(16,16)
	g:SetPoint("TOPLEFT",200,0)
	frame.gTexture = g
  frame.used = true
  return frame
end


local function wipeFrames()
  for _,frame in pairs(requestFrames) do
    frame:Hide()
    frame.used = nil
  end
end

-- MAIN FRAME --

local LFTWhisperFrame = CreateFrame("Frame")
LFTWhisperFrame:RegisterEvent("CHAT_MSG_WHISPER")

local LFTMainFrame = CreateFrame("Frame","LFTMainFrame",UIParent, "LFTMainFrameTemplate")


LFTMainFrame:Hide()

local announceChannel = AnnounceChannel

local announceButton = AnnounceButton
announceButton:SetScript("OnClick", function()
	if availCheckbox:GetChecked() then
	--print("/" .. announceChannel:GetText() .. " Lvl " .. UnitLevel("player") .. " " ..  UnitClass("player") .. ' tank is now open for requests, whisper "LFT help" for more info')
	SendChatMessage("Lvl " .. UnitLevel("player") .. " " ..  UnitClass("player") .. ' tank is now open for requests, whisper "LFT help" for more info' ,"CHANNEL" ,nil ,announceChannel:GetText())
	else
	print("not available")
	end
end)

local availCheckbox = AvailablityCheck

local clearButton = ClearButton
clearButton:SetScript("OnClick", function()
	wipeFrames()
end)

local function createRequestRow(player,dungeon,summon,group,tip)
		local rF = getFrame(LFTMainFrame)
		--rF:SetText(player .. dungeon)
		rF.player = player

		rF.nameString:SetText(player)
		

		rF.dString:SetText(dungeon)
		

		rF.tString:SetText(tip)
		


		if (string.lower(summon) == "yes") then
			rF.sumTexture:SetColorTexture(0.0, 1.0, 0.0, 0.5)
			else
					rF.sumTexture:SetColorTexture(1.0, 0.0, 0.0, 0.5)
		end
		


		if (string.lower(group) == "yes") then
			rF.gTexture:SetColorTexture(0.0, 1.0, 0.0, 0.5)
			else
					rF.gTexture:SetColorTexture(1.0, 0.0, 0.0, 0.5)
		end
		
		
		
		collapseFrames()
end


local function parseLFTRequest(playerName, t)
	local player = string.sub(playerName,1,string.find(playerName,"-")-1)
	local dungeon = t[2]
	local summon = t[3]
	local group = t[4]
	local tip = t[5]
	createRequestRow(player,dungeon,summon,group,tip)
end

local function eventHandler(self, event, ...)
	if availCheckbox:GetChecked() then
		local text, playerName, languageName, channelName, playerName2, specialFlags, zoneChannelID, channelIndex, channelBaseName, unused, lineID, guid, bnSenderID, isMobile, isSubtitle, hideSenderInLetterbox, supressRaidIcons = ...;
		local t = {}
		local welcomeMsg = 'Thank you for contacting my tanking service, LookingForTank or LFT for short. Please whisper me "LFT help" for instructions'
		for i in string.gmatch(text, "%S+") do
			t[#t + 1] = i
		end 
		
		if (t[1] == "LFT" or t[1] == "lft" ) then
			if (t[2] == "help") then
				SendChatMessage("Thank you for contacting my tanking service, LookingForTank or LFT for short." ,"WHISPER" ,nil ,playerName)
				SendChatMessage("Type this to request a tank: LFT dungeon cansummon islastspot tip. No spaces in dungeon name" ,"WHISPER" ,nil ,playerName);
				SendChatMessage("Example #1: LFT DMW yes yes 0g" ,"WHISPER" ,nil ,playerName);
				SendChatMessage("Example #2: LFT MARA no no 2g" ,"WHISPER" ,nil ,playerName);
				SendChatMessage("Tip is not required but appreciated and might give you higher priority" ,"WHISPER" ,nil ,playerName);
			elseif (#t == 5) then
				parseLFTRequest(playerName, t)
				SendChatMessage('Thanks for requesting me as a tank' ,"WHISPER" ,nil ,playerName);
			else
			
				SendChatMessage('Unknown command, try "LFT help" for instructions' ,"WHISPER" ,nil ,playerName);
			end
		elseif (string.match(text, "tank")) then
			SendChatMessage(welcomeMsg ,"WHISPER" ,nil ,playerName);
			--print(welcomeMsg)
		end
	end
	
end

LFTWhisperFrame:SetScript("OnEvent", eventHandler)

function LFTHippHopp()
	if ( LFTMainFrame:IsShown() ) then
        LFTMainFrame:Hide()
	else
		LFTMainFrame:Show()
    end
end

local loadFrame = CreateFrame("FRAME"); -- Need a frame to respond to events
loadFrame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded

function loadFrame.OnEvent(self, event, addon)
	if event == "ADDON_LOADED" and addon == "LookingForTank" then
		if TankAvailability then
			availCheckbox:SetChecked(true)
		else 
			availCheckbox:SetChecked(false)
		end
	
	print(TankAvailability)
	announceChannel:SetText(Channel)
	LFTMainFrame:SetPoint(FramePosition, FrameX, FrameY)
	end
end
loadFrame:SetScript("OnEvent", loadFrame.OnEvent);